unit Unit1;

{$mode objfpc}{$H+}

interface

uses
    Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnGenerate: TButton;
    btnFile: TButton;
    edtAmplitude: TEdit;
    edtFile: TEdit;
    edtSchritt: TEdit;
    edtRise: TEdit;
    Label1: TLabel;
    lblAmplitude: TLabel;
    lblSchritt: TLabel;
    lblAnstieg: TLabel;
    mmoPulses: TMemo;
    SaveDialog1: TSaveDialog;
    procedure btnFileClick(Sender: TObject);
    procedure btnGenerateClick(Sender: TObject);
    procedure edtAmplitudeEditingDone(Sender: TObject);
    procedure edtRiseEditingDone(Sender: TObject);
    procedure edtSchrittEditingDone(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public
    pulses:String;
    FileValid: Boolean;
    pwlfile: Text;
    intervall,
    rise,
    amplitude : Double;
  end;

var
   Form1: TForm1;

implementation

{$R *.frm}

{ TForm1 }


procedure TForm1.FormCreate(Sender: TObject);
begin
  DefaultFormatSettings.DecimalSeparator := '.';  // SPICE Float Format
  mmoPulses.Text := '0011110001010000111100111100010100001111001111000101000011110011110001010000111100111100010100001111';
  FileValid := false;
  edtAmplitudeEditingDone(self);
  edtRiseEditingDone(self);
  edtSchrittEditingDone(self);
  AssignFile(pwlfile,  edtFile.Text);
end;

procedure TForm1.btnFileClick(Sender: TObject);
begin
  FileValid := SaveDialog1.Execute;
  if FileValid then begin
    edtFile.Text := SaveDialog1.Filename;
    AssignFile(pwlfile,  edtFile.Text);
  end;
end;

procedure MyStrToFloat(S :String; var Value: Double);
var
  n: double;
  i: integer;
begin
  for i := 1 to length(S) do
      if s[i] = ',' then S[i] := '.';
  if TryStrToFloat(S, n) then
      Value := n;
end;

procedure TForm1.btnGenerateClick(Sender: TObject);
var
  f: Text;
  n: double;
  s: String;
  i: Integer;

  procedure step(a: double);
  begin
    writeln(f,n * intervall + rise * 1e-9,' ',a);
    n := n + 1e-6;
    writeln(f,n*intervall,' ',a);
  end;

begin
  f := pwlfile;
  s := mmoPulses.Text;
  n := 0.0;
  rewrite(f);
  writeln(f, '0 0');
  Writeln(f, 'REPEAT FOREVER');
  for i := 1 to length(s) do begin
    case s[i] of
    '0':  step(amplitude * -1.0);
    '1':  step(amplitude);
    // Andere Zeichen werden ignoriert
    end;
  end;
  Writeln(f,'ENDREPEAT');
  CloseFile(f);
end;

procedure TForm1.edtAmplitudeEditingDone(Sender: TObject);
begin
  MyStrToFloat(edtAmplitude.Text,amplitude);
  edtAmplitude.Text := FloatToStr(amplitude);
end;

procedure TForm1.edtRiseEditingDone(Sender: TObject);
begin
   MyStrToFloat(edtRise.Text,rise);
   edtRise.Text := FloatToStr(rise);
end;

procedure TForm1.edtSchrittEditingDone(Sender: TObject);
begin
  MyStrToFloat(edtSchritt.Text,intervall);
  edtSchritt.Text := FloatToStr(intervall);
end;

end.

